﻿Imports System.Drawing.Imaging
Imports System.Runtime.InteropServices
Imports System.IO

Public Class Form1
  Dim BoardSize As Integer = 64
  Dim Board(BoardSize - 1, BoardSize - 1) As Integer
  Dim Running As Boolean = False
  Dim rnd As New Random
  Dim Npoints As Integer = 150
  Dim Ent(Npoints) As Integer
  Dim pointer As Integer = 0
  Dim MaxEnt As Integer = (BoardSize + 4) * BoardSize
  Dim generation As Integer = 0
  Dim mistakes As Integer = 0
  Dim BlobData(63) As Long
  Dim GameParameter As Integer

  Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    Timer1.Interval = 100 ' fast
    RadioButton2.Checked = True
    CheckBox5.Checked = True
    CheckBox7.Checked = True
    ReadBlobData()
    SetupBoard()
  End Sub

  Private Sub ReadBlobData()
    Dim t As String = My.Resources.BlobData
    Dim s As String
    For y As Integer = 0 To 63
      s = t.Substring(0, InStr(t, Chr(13)) - 1)
      BlobData(y) = CLng(s)
      'Debug.Print(Str(y) & " " & s & " " & Hex(BlobData(y)))
      t = t.Substring(InStr(t, Chr(10)))
    Next
  End Sub

  Private Sub SetupBoard()
    Dim s As Integer = NumericUpDown1.Value
    For y As Integer = 0 To BoardSize - 1
      For x As Integer = 0 To BoardSize - 1
        Board(x, y) = 0
        Select Case True
          Case RadioButton2.Checked
            If x > 30 And x < 31 + s And y > 30 And y < 31 + s Then Board(x, y) = 1
          Case RadioButton3.Checked
            If x > 10 And x < BoardSize - 11 And y > 30 And y < 31 + s Then Board(x, y) = 1
          Case RadioButton4.Checked
            If x > 30 And x < 31 + s And y > 10 And y < BoardSize - 11 Then Board(x, y) = 1
          Case RadioButton5.Checked
            Dim m As Long = 1
            m = m << x
            If BlobData(y) And m Then Board(x, y) = 1
        End Select
      Next
    Next
  End Sub

  Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
    If CheckBox1.Checked Then Backward() Else Forward()
  End Sub

  Private Sub OneShot_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
    If CheckBox1.Checked Then Backward() Else Forward()
  End Sub

  Private Sub Forward()
    For y As Integer = 0 To BoardSize - 1
      For x As Integer = 0 To BoardSize - 1
        TogglePixel(x, y)
      Next
    Next
    generation += 1
    UpdateDisplay()
  End Sub

  Private Sub Backward()
    For y As Integer = BoardSize - 1 To 0 Step -1
      For x As Integer = BoardSize - 1 To 0 Step -1
        TogglePixel(x, y)
      Next
    Next
    generation += 1
    UpdateDisplay()
  End Sub

  Private Sub TogglePixel(x, y)
    If CheckBox2.Checked Then
      ' either toggle pixel at random
      If rnd.Next(1000000) < NumericUpDown2.Value Then
        Board(x, y) = Board(x, y) Xor 1
        mistakes += 1
      Else
        ' or toggle pixel according to the rule
        If Condition(CountSquare(x, y)) Then Board(x, y) = Board(x, y) Xor 1
      End If
    Else
      If Condition(CountSquare(x, y)) Then Board(x, y) = Board(x, y) Xor 1
    End If
  End Sub

  'If generation = 125 Then
  '  StopRunning()
  '  Dim fs As New FileStream("C:\Users\Oliver\My Projects\Projects\Experimental\Entropy Model\BlobData.txt", FileMode.Create, FileAccess.Write)
  '  Dim sw As New StreamWriter(fs)
  '  Dim t As Long
  '  Dim m As Long
  '  For y As Integer = 0 To 63
  '    t = 0 : m = 1
  '    For x As Integer = 0 To 63
  '      If Board(x, y) = 1 Then t = t Or m
  '      m = m << 1
  '    Next
  '    Debug.Print(Str(y) & " " & Hex(t))
  '    sw.WriteLine("&H" & Hex(t))
  '  Next
  '  sw.Close()
  'End If

  Private Sub UpdateDisplay()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    Label2.Text = "Current entropy =" & Str(TotalEntropy)
    Label3.Text = "Current generation =" & Str(generation)
    Label5.Text = "Total no. of mistakes =" & Str(mistakes)
  End Sub

  Private Function CountSquare(x, y)
    Dim t As Integer = 0
    For q As Integer = y - 1 To y + 1
      For p As Integer = x - 1 To x + 1
        If p >= 0 And p < BoardSize And q >= 0 And q < BoardSize Then t += Board(p, q)
      Next
    Next
    t -= Board(x, y) ' subtract middle pixel
    Return t
  End Function

  Private Function Condition(t) As Boolean
    Dim m As Integer = 1 << t
    Return (GameParameter And m) <> 0
  End Function

  Private Function TotalEntropy()
    Dim E As Integer = 0
    For y As Integer = 0 To BoardSize - 1
      E += Entropy(y)
    Next
    Ent(pointer) = E : pointer += 1
    If pointer > Npoints Then pointer = 0
    Return E
  End Function

  Private Function Entropy(y)
    ' Calculates the entropy of a line (y)
    Dim crossings As Integer = 0
    Dim p As Integer = Board(0, y)
    For x As Integer = 1 To BoardSize - 1
      If Board(x, y) <> p Then crossings += 1 : p = Board(x, y)
    Next
    If crossings > 6 Then
      Return BoardSize + 4
    Else
      Return 5 * crossings + 4
    End If
  End Function

  Private Sub PictureBox1_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseClick
    Board(e.X \ 8, e.Y \ 8) = Board(e.X \ 8, e.Y \ 8) Xor 1
    PictureBox1.Invalidate()
  End Sub

  Private Sub PictureBox1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    PaintBoard(e.Graphics)
  End Sub

  Private Sub PaintBoard(g)
    Dim blackbrush As New SolidBrush(Color.Black)
    Dim graybrush As New SolidBrush(Color.FromArgb(&HE8, &HE8, &HE8))
    For y As Integer = 0 To BoardSize - 1
      For x As Integer = 0 To BoardSize - 1
        If Board(x, y) = 1 Then
          g.FillRectangle(blackbrush, x * 8, y * 8, 8, 8)
        ElseIf (x And 1) Or (y And 1) Then
          g.FillRectangle(graybrush, x * 8, y * 8, 8, 8)
        End If
      Next
    Next
  End Sub

  Private Sub PictureBox2_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox2.Paint
    For i = 0 To Npoints
      e.Graphics.DrawLine(Pens.Blue, i + 3, 100, i + 3, 100 - GetEnt(pointer + i))
    Next
  End Sub

  Private Function GetEnt(i)
    Dim p As Integer = i
    If p > Npoints Then p -= Npoints
    Return Ent(p) * 100 \ MaxEnt
  End Function

  Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    If Running Then
      StopRunning()
    Else
      StartRunning()
    End If
  End Sub

  Private Sub StartRunning()
    Timer1.Start()
    Button1.Text = "Stop"
    GameParameter = 0
    If CheckBox3.Checked Then GameParameter = GameParameter Or 2
    If CheckBox4.Checked Then GameParameter = GameParameter Or 4
    If CheckBox5.Checked Then GameParameter = GameParameter Or 8
    If CheckBox6.Checked Then GameParameter = GameParameter Or 16
    If CheckBox7.Checked Then GameParameter = GameParameter Or 32
    If CheckBox8.Checked Then GameParameter = GameParameter Or 64
    If CheckBox9.Checked Then GameParameter = GameParameter Or 128
    If CheckBox10.Checked Then GameParameter = GameParameter Or 256
    Running = True
  End Sub

  Private Sub StopRunning()
    Timer1.Stop()
    Button1.Text = "Go"
    Running = False
  End Sub

  Private Sub Reset()
    StopRunning()
    SetupBoard()
    generation = 0
    mistakes = 0
    For i As Integer = 0 To Npoints
      Ent(i) = 0
    Next
    pointer = 0
    UpdateDisplay()
  End Sub

  Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
    Reset()
  End Sub

  Private Sub SaveImageButton_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
    SaveFileDialog1.FileName = "Image"
    If SaveFileDialog1.ShowDialog = DialogResult.OK Then
      SaveImage(SaveFileDialog1.FileName)
    End If
  End Sub

  Private Sub SaveImage(filename)
    If Not filename.EndsWith(".png") Then filename &= ".png"
    Dim bm As New Bitmap(BoardSize * 8, BoardSize * 8)
    Dim g As Graphics = Graphics.FromImage(bm)
    PaintBoard(g)
    bm.Save(filename, ImageFormat.Png)
  End Sub

  Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
    Help.Show()
  End Sub

End Class
